Browse Source

Import upstream version 0.4.20

Adam Hupp 6 months ago
parent
commit
49bf87e97f
30 changed files with 1448 additions and 425 deletions
  1. 10 0
      .gitignore
  2. 9 13
      .travis.yml
  3. 54 0
      CHANGELOG
  4. 17 0
      COMPAT.md
  5. 37 0
      LICENSE
  6. 3 0
      MANIFEST.in
  7. 60 36
      README.md
  8. 0 301
      magic.py
  9. 487 0
      magic/__init__.py
  10. 86 0
      magic/__init__.pyi
  11. 288 0
      magic/compat.py
  12. 38 30
      setup.py
  13. 11 0
      test.ps1
  14. 5 0
      test/Dockerfile_archlinux
  15. 8 0
      test/Dockerfile_bionic
  16. 5 0
      test/Dockerfile_centos7
  17. 5 0
      test/Dockerfile_centos8
  18. 8 0
      test/Dockerfile_focal
  19. 8 0
      test/Dockerfile_xenial
  20. 10 0
      test/README
  21. 46 0
      test/libmagic_test.py
  22. 35 0
      test/run.py
  23. 0 14
      test/run.sh
  24. 143 31
      test/test.py
  25. BIN
      test/testdata/name_use.jpg
  26. 1 0
      test/testdata/pgpunicode
  27. BIN
      test/testdata/test.snappy.parquet
  28. 21 0
      test_docker.sh
  29. 47 0
      tox.ini
  30. 6 0
      upload.sh

+ 10 - 0
.gitignore

@@ -1,2 +1,12 @@
+.coverage*
+.tox/
+bin/
 deb_dist
+htmlcov/
+lib/
+__pycache__/
 python_magic.egg-info
+pip-selfcheck.json
+pyvenv.cfg
+*.pyc
+*~

+ 9 - 13
.travis.yml

@@ -1,26 +1,22 @@
 language: python
-
-# needed to use trusty
-sudo: required
-
 dist: xenial
+cache: pip
 
 python:
-  - "2.6"
   - "2.7"
-  - "3.3"
-  - "3.4"
   - "3.5"
   - "3.6"
-  - "nightly"
+  - "3.7"
+  - "3.8"
+  - "3.9"
 
 install:
-  - pip install coverage
-  - python setup.py install
+  - pip install coverage coveralls codecov
+  - pip install .
 
 script:
-  - coverage run setup.py test
+  - LC_ALL=en_US.UTF-8 coverage run -m unittest test
 
 after_success:
-  - pip install coveralls && coveralls
-  - pip install codecov && codecov
+  - coveralls
+  - codecov

+ 54 - 0
CHANGELOG

@@ -0,0 +1,54 @@
+Changes to 0.4.20
+
+- merge in a compatability layer for the upstream libmagic python binding.
+  Since both this package and that one are called 'magic', this compat layer
+  removes a very common source of runtime errors.  Use of that libmagic API will
+  produce a deprecation warning.
+
+- support python 3.9 in tests and pypi metadata
+
+- add support for magic_descriptor functions, which take a file descriptor
+  rather than a filename.
+
+- sometimes the returned description includes snippets of the file, e.g a title
+  for MS Word docs.  Since this is in an unknown encoding, we would throw a
+  unicode decode error trying to decode.  Now, it decodes with
+  'backslashreplace' to handle this more gracefully.  The undecodable characters
+  are replaced with hex escapes.
+
+- add support for MAGIC_EXTENSION, to return possible file extensions.
+
+- add mypy typing stubs file, for type checking
+
+Changes in 0.4.18
+
+- Make bindings for magic_[set|get]param optional, and throw NotImplementedError
+if they are used but not supported.  Only call setparam() in the constructor if
+it's supported. This prevents breakage on CentOS7 which uses an old version of
+libmagic.
+
+- Add tests for CentOS 7 & 8
+
+Changes in 0.4.16 and 0.4.17
+
+- add MAGIC_MIME_TYPE constant, use that in preference to MAGIC_MIME internally.
+This sets up for a breaking change in a future major version bump where
+MAGIC_MIME will change to mathch magic.h.
+- add magic.version() function to return library version
+- add setparam/getparam to control internal behavior
+- increase internal limits with setparam to prevent spurious error on some jpeg files
+- various setup.py improvements to declare modern python support
+- support MSYS2 magic dlls
+- fix warning about using 'is' on an int in python 3.8
+- include tests in source distribution
+
+- many test improvements:
+-- tox runner support
+-- remove deprecated test_suite field from setup.py
+-- docker tests that cover all LTS ubuntu versions
+-- add test for snapp file identification
+
+- doc improvements
+-- document dependency install process for debian
+-- various typos
+-- document test running process

+ 17 - 0
COMPAT.md

@@ -0,0 +1,17 @@
+There are two python modules named 'magic' that do the same thing, but
+with incompatible APIs.  One of these ships with libmagic, and (this one) is
+distributed through pypi.  Both have been around for many years and have
+substantial user bases.  This incompatability is a major source of pain for
+users, and bug reports for me.
+
+To mitigate this pain, python-magic has added a compatability layer to export
+the libmagic python API parallel to the existing one.
+
+The mapping between the libmagic and python-magic functions is:
+
+    detect_from_filename => from_file
+    detect_from_content => from_buffer
+    detect_from_fobj => from_descriptor(f.fileno())
+    open => Magic()
+
+

+ 37 - 0
LICENSE

@@ -19,3 +19,40 @@ AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 SOFTWARE.
+
+
+====
+
+Portions of this package (magic/compat.py and test/libmagic_test.py)
+are distributed under the following copyright notice:
+
+
+$File: LEGAL.NOTICE,v 1.15 2006/05/03 18:48:33 christos Exp $
+Copyright (c) Ian F. Darwin 1986, 1987, 1989, 1990, 1991, 1992, 1994, 1995.
+Software written by Ian F. Darwin and others;
+maintained 1994- Christos Zoulas.
+
+This software is not subject to any export provision of the United States
+Department of Commerce, and may be exported to any country or planet.
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions
+are met:
+1. Redistributions of source code must retain the above copyright
+   notice immediately at the beginning of the file, without modification,
+   this list of conditions, and the following disclaimer.
+2. Redistributions in binary form must reproduce the above copyright
+   notice, this list of conditions and the following disclaimer in the
+   documentation and/or other materials provided with the distribution.
+
+THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
+ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+SUCH DAMAGE.

+ 3 - 0
MANIFEST.in

@@ -1,2 +1,5 @@
 include *.py
 include LICENSE
+graft tests
+global-exclude __pycache__
+global-exclude *.py[co]

+ 60 - 36
README.md

@@ -2,7 +2,7 @@
 [![PyPI version](https://badge.fury.io/py/python-magic.svg)](https://badge.fury.io/py/python-magic)
 [![Build Status](https://travis-ci.org/ahupp/python-magic.svg?branch=master)](https://travis-ci.org/ahupp/python-magic)
 
-python-magic is a python interface to the libmagic file type
+python-magic is a Python interface to the libmagic file type
 identification library.  libmagic identifies file types by checking
 their headers according to a predefined list of file types. This
 functionality is exposed to the command line by the Unix command
@@ -14,7 +14,8 @@ functionality is exposed to the command line by the Unix command
 >>> import magic
 >>> magic.from_file("testdata/test.pdf")
 'PDF document, version 1.2'
->>> magic.from_buffer(open("testdata/test.pdf").read(1024))
+# recommend using at least the first 2048 bytes, as less can produce incorrect identification
+>>> magic.from_buffer(open("testdata/test.pdf", "rb").read(2048))
 'PDF document, version 1.2'
 >>> magic.from_file("testdata/test.pdf", mime=True)
 'application/pdf'
@@ -41,34 +42,32 @@ You can also combine the flag options:
 'text/plain'
 ```
 
-## Versioning
-
-Minor version bumps should be backwards compatible.  Major bumps are not.
-
-## Name Conflict
-
-There are, sadly, two libraries which use the module name `magic`.  Both have been around for quite a while.If you are using this module and get an error using a method like `open`, your code is expecting the other one.  Hopefully one day these will be reconciled.
-
 ## Installation
 
-The current stable version of python-magic is available on pypi and
+The current stable version of python-magic is available on PyPI and
 can be installed by running `pip install python-magic`.
 
 Other sources:
 
-- pypi: http://pypi.python.org/pypi/python-magic/
-- github: https://github.com/ahupp/python-magic
+- PyPI: http://pypi.python.org/pypi/python-magic/
+- GitHub: https://github.com/ahupp/python-magic
 
-### Windows
+This module is a simple wrapper around the libmagic C library, and
+that must be installed as well:
 
-You'll need DLLs for libmagic.  @julian-r has uploaded a versoin of this project that includes binaries to pypi:
-https://pypi.python.org/pypi/python-magic-bin/0.4.14
+### Debian/Ubuntu
 
-Other sources of the libraries in the past have been [File for Windows](http://gnuwin32.sourceforge.net/packages/file.htm) .  You will need to copy the file `magic` out of `[binary-zip]\share\misc`, and pass it's location to `Magic(magic_file=...)`.  
+```
+sudo apt-get install libmagic1
+```
 
-If you are using a 64-bit build of python, you'll need 64-bit libmagic binaries which can be found here: https://github.com/pidydx/libmagicwin64. Newer version can be found here: https://github.com/nscaife/file-windows.
+### Windows
 
+You'll need DLLs for libmagic.  @julian-r maintains a pypi package with the DLLs, you can fetch it with:
 
+```
+pip install python-magic-bin
+```
 
 ### OSX
 
@@ -84,11 +83,50 @@ If you are using a 64-bit build of python, you'll need 64-bit libmagic binaries
 
 - 'WindowsError: [Error 193] %1 is not a valid Win32 application':
   Attempting to run the 32-bit libmagic DLL in a 64-bit build of
-  python will fail with this error.  Here are 64-bit builds of libmagic for windows: https://github.com/pidydx/libmagicwin64
+  python will fail with this error.  Here are 64-bit builds of libmagic for windows: https://github.com/pidydx/libmagicwin64.
+  Newer version can be found here: https://github.com/nscaife/file-windows.
 
-- 'WindowsError: exception: access violation writing 0x00000000 ' This may indicate you are mixing 
+- 'WindowsError: exception: access violation writing 0x00000000 ' This may indicate you are mixing
   Windows Python and Cygwin Python. Make sure your libmagic and python builds are consistent.
 
+
+## Bug Reports
+
+python-magic is a thin layer over the libmagic C library.
+Historically, most bugs that have been reported against python-magic
+are actually bugs in libmagic; libmagic bugs can be reported on their
+tracker here: https://bugs.astron.com/my_view_page.php.  If you're not
+sure where the bug lies feel free to file an issue on GitHub and I can
+triage it.
+
+## Running the tests
+
+To run the tests across a variety of linux distributions (depends on Docker):
+
+```
+./test_docker.sh
+```
+
+To run tests locally across all available python versions:
+
+```
+./test/run.py
+```
+
+To run against a specific python version:
+
+```
+LC_ALL=en_US.UTF-8 python3 test/test.py
+```
+
+## libmagic and python-magic
+
+See [COMPAT.md](COMPAT.md) for a guide to libmagic / python-magic compatability.
+
+## Versioning
+
+Minor version bumps should be backwards compatible.  Major bumps are not.
+
 ## Author
 
 Written by Adam Hupp in 2001 for a project that never got off the
@@ -96,25 +134,11 @@ ground.  It originally used SWIG for the C library bindings, but
 switched to ctypes once that was part of the python standard library.
 
 You can contact me via my [website](http://hupp.org/adam) or
-[github](http://github.com/ahupp).
-
-## Contributors
-
-Thanks to these folks on github who submitted features and bugfixes.
-
--   Amit Sethi
--   [bigben87](https://github.com/bigben87)
--   [fallgesetz](https://github.com/fallgesetz)
--   [FlaPer87](https://github.com/FlaPer87)
--   [lukenowak](https://github.com/lukenowak)
--   NicolasDelaby
--   sacha@ssl.co.uk
--   SimpleSeb
--   [tehmaze](https://github.com/tehmaze)
+[GitHub](http://github.com/ahupp).
 
 ## License
 
 python-magic is distributed under the MIT license.  See the included
 LICENSE file for details.
 
-
+I am providing code in the repository to you under an open source license. Because this is my personal repository, the license you receive to my code is from me and not my employer (Facebook).

+ 0 - 301
magic.py

@@ -1,301 +0,0 @@
-"""
-magic is a wrapper around the libmagic file identification library.
-
-See README for more information.
-
-Usage:
-
->>> import magic
->>> magic.from_file("testdata/test.pdf")
-'PDF document, version 1.2'
->>> magic.from_file("testdata/test.pdf", mime=True)
-'application/pdf'
->>> magic.from_buffer(open("testdata/test.pdf").read(1024))
-'PDF document, version 1.2'
->>>
-
-
-"""
-
-import sys
-import glob
-import os.path
-import ctypes
-import ctypes.util
-import threading
-
-from ctypes import c_char_p, c_int, c_size_t, c_void_p
-
-
-class MagicException(Exception):
-    def __init__(self, message):
-        super(MagicException, self).__init__(message)
-        self.message = message
-
-
-class Magic:
-    """
-    Magic is a wrapper around the libmagic C library.
-
-    """
-
-    def __init__(self, mime=False, magic_file=None, mime_encoding=False,
-                 keep_going=False, uncompress=False):
-        """
-        Create a new libmagic wrapper.
-
-        mime - if True, mimetypes are returned instead of textual descriptions
-        mime_encoding - if True, codec is returned
-        magic_file - use a mime database other than the system default
-        keep_going - don't stop at the first match, keep going
-        uncompress - Try to look inside compressed files.
-        """
-        self.flags = MAGIC_NONE
-        if mime:
-            self.flags |= MAGIC_MIME
-        if mime_encoding:
-            self.flags |= MAGIC_MIME_ENCODING
-        if keep_going:
-            self.flags |= MAGIC_CONTINUE
-
-        if uncompress:
-            self.flags |= MAGIC_COMPRESS
-
-        self.cookie = magic_open(self.flags)
-        self.lock = threading.Lock()
-        
-        magic_load(self.cookie, magic_file)
-
-    def from_buffer(self, buf):
-        """
-        Identify the contents of `buf`
-        """
-        with self.lock:
-            try:
-                # if we're on python3, convert buf to bytes
-                # otherwise this string is passed as wchar*
-                # which is not what libmagic expects
-                if type(buf) == str and str != bytes:
-                   buf = buf.encode('utf-8', errors='replace')
-                return maybe_decode(magic_buffer(self.cookie, buf))
-            except MagicException as e:
-                return self._handle509Bug(e)
-
-    def from_file(self, filename):
-        # raise FileNotFoundException or IOError if the file does not exist
-        with open(filename):
-            pass
-        with self.lock:
-            try:
-                return maybe_decode(magic_file(self.cookie, filename))
-            except MagicException as e:
-                return self._handle509Bug(e)
-
-    def _handle509Bug(self, e):
-        # libmagic 5.09 has a bug where it might fail to identify the
-        # mimetype of a file and returns null from magic_file (and
-        # likely _buffer), but also does not return an error message.
-        if e.message is None and (self.flags & MAGIC_MIME):
-            return "application/octet-stream"
-        else:
-            raise e
-        
-    def __del__(self):
-        # no _thread_check here because there can be no other
-        # references to this object at this point.
-
-        # during shutdown magic_close may have been cleared already so
-        # make sure it exists before using it.
-
-        # the self.cookie check should be unnecessary and was an
-        # incorrect fix for a threading problem, however I'm leaving
-        # it in because it's harmless and I'm slightly afraid to
-        # remove it.
-        if self.cookie and magic_close:
-            magic_close(self.cookie)
-            self.cookie = None
-
-_instances = {}
-
-def _get_magic_type(mime):
-    i = _instances.get(mime)
-    if i is None:
-        i = _instances[mime] = Magic(mime=mime)
-    return i
-
-def from_file(filename, mime=False):
-    """"
-    Accepts a filename and returns the detected filetype.  Return
-    value is the mimetype if mime=True, otherwise a human readable
-    name.
-
-    >>> magic.from_file("testdata/test.pdf", mime=True)
-    'application/pdf'
-    """
-    m = _get_magic_type(mime)
-    return m.from_file(filename)
-
-def from_buffer(buffer, mime=False):
-    """
-    Accepts a binary string and returns the detected filetype.  Return
-    value is the mimetype if mime=True, otherwise a human readable
-    name.
-
-    >>> magic.from_buffer(open("testdata/test.pdf").read(1024))
-    'PDF document, version 1.2'
-    """
-    m = _get_magic_type(mime)
-    return m.from_buffer(buffer)
-
-
-
-
-libmagic = None
-# Let's try to find magic or magic1
-dll = ctypes.util.find_library('magic') or ctypes.util.find_library('magic1') or ctypes.util.find_library('cygmagic-1')
-
-# This is necessary because find_library returns None if it doesn't find the library
-if dll:
-    libmagic = ctypes.CDLL(dll)
-
-if not libmagic or not libmagic._name:
-    windows_dlls = ['magic1.dll','cygmagic-1.dll']
-    platform_to_lib = {'darwin': ['/opt/local/lib/libmagic.dylib',
-                                  '/usr/local/lib/libmagic.dylib'] +
-                         # Assumes there will only be one version installed
-                         glob.glob('/usr/local/Cellar/libmagic/*/lib/libmagic.dylib'),
-                       'win32': windows_dlls,
-                       'cygwin': windows_dlls,
-                       'linux': ['libmagic.so.1'],    # fallback for some Linuxes (e.g. Alpine) where library search does not work
-                      }
-    platform = 'linux' if sys.platform.startswith('linux') else sys.platform
-    for dll in platform_to_lib.get(platform, []):
-        try:
-            libmagic = ctypes.CDLL(dll)
-            break
-        except OSError:
-            pass
-
-if not libmagic or not libmagic._name:
-    # It is better to raise an ImportError since we are importing magic module
-    raise ImportError('failed to find libmagic.  Check your installation')
-
-magic_t = ctypes.c_void_p
-
-def errorcheck_null(result, func, args):
-    if result is None:
-        err = magic_error(args[0])
-        raise MagicException(err)
-    else:
-        return result
-
-def errorcheck_negative_one(result, func, args):
-    if result is -1:
-        err = magic_error(args[0])
-        raise MagicException(err)
-    else:
-        return result
-
-
-# return str on python3.  Don't want to unconditionally
-# decode because that results in unicode on python2
-def maybe_decode(s):
-    if str == bytes:
-        return s
-    else:
-        return s.decode('utf-8')
-    
-def coerce_filename(filename):
-    if filename is None:
-        return None
-
-    # ctypes will implicitly convert unicode strings to bytes with
-    # .encode('ascii').  If you use the filesystem encoding 
-    # then you'll get inconsistent behavior (crashes) depending on the user's
-    # LANG environment variable
-    is_unicode = (sys.version_info[0] <= 2 and
-                  isinstance(filename, unicode)) or \
-                  (sys.version_info[0] >= 3 and
-                   isinstance(filename, str))
-    if is_unicode:
-        return filename.encode('utf-8', 'surrogateescape')
-    else:
-        return filename
-
-magic_open = libmagic.magic_open
-magic_open.restype = magic_t
-magic_open.argtypes = [c_int]
-
-magic_close = libmagic.magic_close
-magic_close.restype = None
-magic_close.argtypes = [magic_t]
-
-magic_error = libmagic.magic_error
-magic_error.restype = c_char_p
-magic_error.argtypes = [magic_t]
-
-magic_errno = libmagic.magic_errno
-magic_errno.restype = c_int
-magic_errno.argtypes = [magic_t]
-
-_magic_file = libmagic.magic_file
-_magic_file.restype = c_char_p
-_magic_file.argtypes = [magic_t, c_char_p]
-_magic_file.errcheck = errorcheck_null
-
-def magic_file(cookie, filename):
-    return _magic_file(cookie, coerce_filename(filename))
-
-_magic_buffer = libmagic.magic_buffer
-_magic_buffer.restype = c_char_p
-_magic_buffer.argtypes = [magic_t, c_void_p, c_size_t]
-_magic_buffer.errcheck = errorcheck_null
-
-def magic_buffer(cookie, buf):
-    return _magic_buffer(cookie, buf, len(buf))
-
-
-_magic_load = libmagic.magic_load
-_magic_load.restype = c_int
-_magic_load.argtypes = [magic_t, c_char_p]
-_magic_load.errcheck = errorcheck_negative_one
-
-def magic_load(cookie, filename):
-    return _magic_load(cookie, coerce_filename(filename))
-
-magic_setflags = libmagic.magic_setflags
-magic_setflags.restype = c_int
-magic_setflags.argtypes = [magic_t, c_int]
-
-magic_check = libmagic.magic_check
-magic_check.restype = c_int
-magic_check.argtypes = [magic_t, c_char_p]
-
-magic_compile = libmagic.magic_compile
-magic_compile.restype = c_int
-magic_compile.argtypes = [magic_t, c_char_p]
-
-
-
-MAGIC_NONE = 0x000000 # No flags
-MAGIC_DEBUG = 0x000001 # Turn on debugging
-MAGIC_SYMLINK = 0x000002 # Follow symlinks
-MAGIC_COMPRESS = 0x000004 # Check inside compressed files
-MAGIC_DEVICES = 0x000008 # Look at the contents of devices
-MAGIC_MIME = 0x000010 # Return a mime string
-MAGIC_MIME_ENCODING = 0x000400 # Return the MIME encoding
-MAGIC_CONTINUE = 0x000020 # Return all matches
-MAGIC_CHECK = 0x000040 # Print warnings to stderr
-MAGIC_PRESERVE_ATIME = 0x000080 # Restore access time on exit
-MAGIC_RAW = 0x000100 # Don't translate unprintable chars
-MAGIC_ERROR = 0x000200 # Handle ENOENT etc as real errors
-
-MAGIC_NO_CHECK_COMPRESS = 0x001000 # Don't check for compressed files
-MAGIC_NO_CHECK_TAR = 0x002000 # Don't check for tar files
-MAGIC_NO_CHECK_SOFT = 0x004000 # Don't check magic entries
-MAGIC_NO_CHECK_APPTYPE = 0x008000 # Don't check application type
-MAGIC_NO_CHECK_ELF = 0x010000 # Don't check for elf details
-MAGIC_NO_CHECK_ASCII = 0x020000 # Don't check for ascii files
-MAGIC_NO_CHECK_TROFF = 0x040000 # Don't check ascii/troff
-MAGIC_NO_CHECK_FORTRAN = 0x080000 # Don't check ascii/fortran
-MAGIC_NO_CHECK_TOKENS = 0x100000 # Don't check ascii/tokens

+ 487 - 0
magic/__init__.py

@@ -0,0 +1,487 @@
+"""
+magic is a wrapper around the libmagic file identification library.
+
+See README for more information.
+
+Usage:
+
+>>> import magic
+>>> magic.from_file("testdata/test.pdf")
+'PDF document, version 1.2'
+>>> magic.from_file("testdata/test.pdf", mime=True)
+'application/pdf'
+>>> magic.from_buffer(open("testdata/test.pdf").read(1024))
+'PDF document, version 1.2'
+>>>
+
+"""
+
+import sys
+import glob
+import ctypes
+import ctypes.util
+import threading
+import logging
+
+from ctypes import c_char_p, c_int, c_size_t, c_void_p, byref, POINTER
+
+# avoid shadowing the real open with the version from compat.py
+_real_open = open
+
+
+class MagicException(Exception):
+    def __init__(self, message):
+        super(Exception, self).__init__(message)
+        self.message = message
+
+
+class Magic:
+    """
+    Magic is a wrapper around the libmagic C library.
+    """
+
+    def __init__(self, mime=False, magic_file=None, mime_encoding=False,
+                 keep_going=False, uncompress=False, raw=False, extension=False):
+        """
+        Create a new libmagic wrapper.
+
+        mime - if True, mimetypes are returned instead of textual descriptions
+        mime_encoding - if True, codec is returned
+        magic_file - use a mime database other than the system default
+        keep_going - don't stop at the first match, keep going
+        uncompress - Try to look inside compressed files.
+        raw - Do not try to decode "non-printable" chars.
+        extension - Print a slash-separated list of valid extensions for the file type found.
+        """
+
+        self.cookie = None
+        self.flags = MAGIC_NONE
+        if mime:
+            self.flags |= MAGIC_MIME_TYPE
+        if mime_encoding:
+            self.flags |= MAGIC_MIME_ENCODING
+        if keep_going:
+            self.flags |= MAGIC_CONTINUE
+        if uncompress:
+            self.flags |= MAGIC_COMPRESS
+        if raw:
+            self.flags |= MAGIC_RAW
+        if extension:
+            self.flags |= MAGIC_EXTENSION
+
+        self.cookie = magic_open(self.flags)
+        self.lock = threading.Lock()
+
+        magic_load(self.cookie, magic_file)
+
+        # MAGIC_EXTENSION was added in 523 or 524, so bail if
+        # it doesn't appear to be available
+        if extension and (not _has_version or version() < 524):
+            raise NotImplementedError('MAGIC_EXTENSION is not supported in this version of libmagic')
+
+        # For https://github.com/ahupp/python-magic/issues/190
+        # libmagic has fixed internal limits that some files exceed, causing
+        # an error.  We can avoid this (at least for the sample file given)
+        # by bumping the limit up.  It's not clear if this is a general solution
+        # or whether other internal limits should be increased, but given
+        # the lack of other reports I'll assume this is rare.
+        if _has_param:
+            try:
+                self.setparam(MAGIC_PARAM_NAME_MAX, 64)
+            except MagicException as e:
+                # some versions of libmagic fail this call,
+                # so rather than fail hard just use default behavior
+                pass
+
+    def from_buffer(self, buf):
+        """
+        Identify the contents of `buf`
+        """
+        with self.lock:
+            try:
+                # if we're on python3, convert buf to bytes
+                # otherwise this string is passed as wchar*
+                # which is not what libmagic expects
+                if type(buf) == str and str != bytes:
+                    buf = buf.encode('utf-8', errors='replace')
+                return maybe_decode(magic_buffer(self.cookie, buf))
+            except MagicException as e:
+                return self._handle509Bug(e)
+
+    def from_file(self, filename):
+        # raise FileNotFoundException or IOError if the file does not exist
+        with _real_open(filename):
+            pass
+
+        with self.lock:
+            try:
+                return maybe_decode(magic_file(self.cookie, filename))
+            except MagicException as e:
+                return self._handle509Bug(e)
+
+    def from_descriptor(self, fd):
+        with self.lock:
+            try:
+                return maybe_decode(magic_descriptor(self.cookie, fd))
+            except MagicException as e:
+                return self._handle509Bug(e)
+
+    def _handle509Bug(self, e):
+        # libmagic 5.09 has a bug where it might fail to identify the
+        # mimetype of a file and returns null from magic_file (and
+        # likely _buffer), but also does not return an error message.
+        if e.message is None and (self.flags & MAGIC_MIME_TYPE):
+            return "application/octet-stream"
+        else:
+            raise e
+
+    def setparam(self, param, val):
+        return magic_setparam(self.cookie, param, val)
+
+    def getparam(self, param):
+        return magic_getparam(self.cookie, param)
+
+    def __del__(self):
+        # no _thread_check here because there can be no other
+        # references to this object at this point.
+
+        # during shutdown magic_close may have been cleared already so
+        # make sure it exists before using it.
+
+        # the self.cookie check should be unnecessary and was an
+        # incorrect fix for a threading problem, however I'm leaving
+        # it in because it's harmless and I'm slightly afraid to
+        # remove it.
+        if self.cookie and magic_close:
+            magic_close(self.cookie)
+            self.cookie = None
+
+
+_instances = {}
+
+
+def _get_magic_type(mime):
+    i = _instances.get(mime)
+    if i is None:
+        i = _instances[mime] = Magic(mime=mime)
+    return i
+
+
+def from_file(filename, mime=False):
+    """"
+    Accepts a filename and returns the detected filetype.  Return
+    value is the mimetype if mime=True, otherwise a human readable
+    name.
+
+    >>> magic.from_file("testdata/test.pdf", mime=True)
+    'application/pdf'
+    """
+    m = _get_magic_type(mime)
+    return m.from_file(filename)
+
+
+def from_buffer(buffer, mime=False):
+    """
+    Accepts a binary string and returns the detected filetype.  Return
+    value is the mimetype if mime=True, otherwise a human readable
+    name.
+
+    >>> magic.from_buffer(open("testdata/test.pdf").read(1024))
+    'PDF document, version 1.2'
+    """
+    m = _get_magic_type(mime)
+    return m.from_buffer(buffer)
+
+
+def from_descriptor(fd, mime=False):
+    """
+    Accepts a file descriptor and returns the detected filetype.  Return
+    value is the mimetype if mime=True, otherwise a human readable
+    name.
+
+    >>> f = open("testdata/test.pdf")
+    >>> magic.from_descriptor(f.fileno())
+    'PDF document, version 1.2'
+    """
+    m = _get_magic_type(mime)
+    return m.from_descriptor(fd)
+
+
+libmagic = None
+# Let's try to find magic or magic1
+dll = ctypes.util.find_library('magic') \
+      or ctypes.util.find_library('magic1') \
+      or ctypes.util.find_library('cygmagic-1') \
+      or ctypes.util.find_library('libmagic-1') \
+      or ctypes.util.find_library('msys-magic-1')  # for MSYS2
+
+# necessary because find_library returns None if it doesn't find the library
+if dll:
+    libmagic = ctypes.CDLL(dll)
+
+if not libmagic or not libmagic._name:
+    windows_dlls = ['magic1.dll', 'cygmagic-1.dll', 'libmagic-1.dll', 'msys-magic-1.dll']
+    platform_to_lib = {'darwin': ['/opt/local/lib/libmagic.dylib',
+                                  '/usr/local/lib/libmagic.dylib'] +
+                                 # Assumes there will only be one version installed
+                                 glob.glob('/usr/local/Cellar/libmagic/*/lib/libmagic.dylib'),  # flake8:noqa
+                       'win32': windows_dlls,
+                       'cygwin': windows_dlls,
+                       'linux': ['libmagic.so.1'],
+                       # fallback for some Linuxes (e.g. Alpine) where library search does not work # flake8:noqa
+                       }
+    platform = 'linux' if sys.platform.startswith('linux') else sys.platform
+    for dll in platform_to_lib.get(platform, []):
+        try:
+            libmagic = ctypes.CDLL(dll)
+            break
+        except OSError:
+            pass
+
+if not libmagic or not libmagic._name:
+    # It is better to raise an ImportError since we are importing magic module
+    raise ImportError('failed to find libmagic.  Check your installation')
+
+magic_t = ctypes.c_void_p
+
+
+def errorcheck_null(result, func, args):
+    if result is None:
+        err = magic_error(args[0])
+        raise MagicException(err)
+    else:
+        return result
+
+
+def errorcheck_negative_one(result, func, args):
+    if result == -1:
+        err = magic_error(args[0])
+        raise MagicException(err)
+    else:
+        return result
+
+
+# return str on python3.  Don't want to unconditionally
+# decode because that results in unicode on python2
+def maybe_decode(s):
+    if str == bytes:
+        return s
+    else:
+        # backslashreplace here because sometimes libmagic will return metadata in the charset
+        # of the file, which is unknown to us (e.g the title of a Word doc)
+        return s.decode('utf-8', 'backslashreplace')
+
+
+def coerce_filename(filename):
+    if filename is None:
+        return None
+    # ctypes will implicitly convert unicode strings to bytes with
+    # .encode('ascii').  If you use the filesystem encoding
+    # then you'll get inconsistent behavior (crashes) depending on the user's
+    # LANG environment variable
+    is_unicode = (sys.version_info[0] <= 2 and
+                 isinstance(filename, unicode)) or \
+                 (sys.version_info[0] >= 3 and
+                  isinstance(filename, str))
+    if is_unicode:
+        return filename.encode('utf-8', 'surrogateescape')
+    else:
+        return filename
+
+
+magic_open = libmagic.magic_open
+magic_open.restype = magic_t
+magic_open.argtypes = [c_int]
+
+magic_close = libmagic.magic_close
+magic_close.restype = None
+magic_close.argtypes = [magic_t]
+
+magic_error = libmagic.magic_error
+magic_error.restype = c_char_p
+magic_error.argtypes = [magic_t]
+
+magic_errno = libmagic.magic_errno
+magic_errno.restype = c_int
+magic_errno.argtypes = [magic_t]
+
+_magic_file = libmagic.magic_file
+_magic_file.restype = c_char_p
+_magic_file.argtypes = [magic_t, c_char_p]
+_magic_file.errcheck = errorcheck_null
+
+
+def magic_file(cookie, filename):
+    return _magic_file(cookie, coerce_filename(filename))
+
+
+_magic_buffer = libmagic.magic_buffer
+_magic_buffer.restype = c_char_p
+_magic_buffer.argtypes = [magic_t, c_void_p, c_size_t]
+_magic_buffer.errcheck = errorcheck_null
+
+
+def magic_buffer(cookie, buf):
+    return _magic_buffer(cookie, buf, len(buf))
+
+
+magic_descriptor = libmagic.magic_descriptor
+magic_descriptor.restype = c_char_p
+magic_descriptor.argtypes = [magic_t, c_int]
+magic_descriptor.errcheck = errorcheck_null
+
+_magic_descriptor = libmagic.magic_descriptor
+_magic_descriptor.restype = c_char_p
+_magic_descriptor.argtypes = [magic_t, c_int]
+_magic_descriptor.errcheck = errorcheck_null
+
+
+def magic_descriptor(cookie, fd):
+    return _magic_descriptor(cookie, fd)
+
+
+_magic_load = libmagic.magic_load
+_magic_load.restype = c_int
+_magic_load.argtypes = [magic_t, c_char_p]
+_magic_load.errcheck = errorcheck_negative_one
+
+
+def magic_load(cookie, filename):
+    return _magic_load(cookie, coerce_filename(filename))
+
+
+magic_setflags = libmagic.magic_setflags
+magic_setflags.restype = c_int
+magic_setflags.argtypes = [magic_t, c_int]
+
+magic_check = libmagic.magic_check
+magic_check.restype = c_int
+magic_check.argtypes = [magic_t, c_char_p]
+
+magic_compile = libmagic.magic_compile
+magic_compile.restype = c_int
+magic_compile.argtypes = [magic_t, c_char_p]
+
+_has_param = False
+if hasattr(libmagic, 'magic_setparam') and hasattr(libmagic, 'magic_getparam'):
+    _has_param = True
+    _magic_setparam = libmagic.magic_setparam
+    _magic_setparam.restype = c_int
+    _magic_setparam.argtypes = [magic_t, c_int, POINTER(c_size_t)]
+    _magic_setparam.errcheck = errorcheck_negative_one
+
+    _magic_getparam = libmagic.magic_getparam
+    _magic_getparam.restype = c_int
+    _magic_getparam.argtypes = [magic_t, c_int, POINTER(c_size_t)]
+    _magic_getparam.errcheck = errorcheck_negative_one
+
+
+def magic_setparam(cookie, param, val):
+    if not _has_param:
+        raise NotImplementedError("magic_setparam not implemented")
+    v = c_size_t(val)
+    return _magic_setparam(cookie, param, byref(v))
+
+
+def magic_getparam(cookie, param):
+    if not _has_param:
+        raise NotImplementedError("magic_getparam not implemented")
+    val = c_size_t()
+    _magic_getparam(cookie, param, byref(val))
+    return val.value
+
+
+_has_version = False
+if hasattr(libmagic, "magic_version"):
+    _has_version = True
+    magic_version = libmagic.magic_version
+    magic_version.restype = c_int
+    magic_version.argtypes = []
+
+
+def version():
+    if not _has_version:
+        raise NotImplementedError("magic_version not implemented")
+    return magic_version()
+
+
+MAGIC_NONE = 0x000000  # No flags
+MAGIC_DEBUG = 0x000001  # Turn on debugging
+MAGIC_SYMLINK = 0x000002  # Follow symlinks
+MAGIC_COMPRESS = 0x000004  # Check inside compressed files
+MAGIC_DEVICES = 0x000008  # Look at the contents of devices
+MAGIC_MIME_TYPE = 0x000010  # Return a mime string
+MAGIC_MIME_ENCODING = 0x000400  # Return the MIME encoding
+# TODO:  should be
+# MAGIC_MIME = MAGIC_MIME_TYPE | MAGIC_MIME_ENCODING
+MAGIC_MIME = 0x000010  # Return a mime string
+MAGIC_EXTENSION = 0x1000000  # Return a /-separated list of extensions
+
+MAGIC_CONTINUE = 0x000020  # Return all matches
+MAGIC_CHECK = 0x000040  # Print warnings to stderr
+MAGIC_PRESERVE_ATIME = 0x000080  # Restore access time on exit
+MAGIC_RAW = 0x000100  # Don't translate unprintable chars
+MAGIC_ERROR = 0x000200  # Handle ENOENT etc as real errors
+
+MAGIC_NO_CHECK_COMPRESS = 0x001000  # Don't check for compressed files
+MAGIC_NO_CHECK_TAR = 0x002000  # Don't check for tar files
+MAGIC_NO_CHECK_SOFT = 0x004000  # Don't check magic entries
+MAGIC_NO_CHECK_APPTYPE = 0x008000  # Don't check application type
+MAGIC_NO_CHECK_ELF = 0x010000  # Don't check for elf details
+MAGIC_NO_CHECK_ASCII = 0x020000  # Don't check for ascii files
+MAGIC_NO_CHECK_TROFF = 0x040000  # Don't check ascii/troff
+MAGIC_NO_CHECK_FORTRAN = 0x080000  # Don't check ascii/fortran
+MAGIC_NO_CHECK_TOKENS = 0x100000  # Don't check ascii/tokens
+
+MAGIC_PARAM_INDIR_MAX = 0  # Recursion limit for indirect magic
+MAGIC_PARAM_NAME_MAX = 1  # Use count limit for name/use magic
+MAGIC_PARAM_ELF_PHNUM_MAX = 2  # Max ELF notes processed
+MAGIC_PARAM_ELF_SHNUM_MAX = 3  # Max ELF program sections processed
+MAGIC_PARAM_ELF_NOTES_MAX = 4  # # Max ELF sections processed
+MAGIC_PARAM_REGEX_MAX = 5  # Length limit for regex searches
+MAGIC_PARAM_BYTES_MAX = 6  # Max number of bytes to read from file
+
+
+# This package name conflicts with the one provided by upstream
+# libmagic.  This is a common source of confusion for users.  To
+# resolve, We ship a copy of that module, and expose it's functions
+# wrapped in deprecation warnings.
+def _add_compat(to_module):
+    import warnings, re
+    from magic import compat
+
+    def deprecation_wrapper(fn):
+        def _(*args, **kwargs):
+            warnings.warn(
+                "Using compatability mode with libmagic's python binding. "
+                "See https://github.com/ahupp/python-magic/blob/master/COMPAT.md for details.",
+                PendingDeprecationWarning)
+
+            return fn(*args, **kwargs)
+
+        return _
+
+    fn = ['detect_from_filename',
+          'detect_from_content',
+          'detect_from_fobj',
+          'open']
+    for fname in fn:
+        to_module[fname] = deprecation_wrapper(compat.__dict__[fname])
+
+    # copy constants over, ensuring there's no conflicts
+    is_const_re = re.compile("^[A-Z_]+$")
+    allowed_inconsistent = set(['MAGIC_MIME'])
+    for name, value in compat.__dict__.items():
+        if is_const_re.match(name):
+            if name in to_module:
+                if name in allowed_inconsistent:
+                    continue
+                if to_module[name] != value:
+                    raise Exception("inconsistent value for " + name)
+                else:
+                    continue
+            else:
+                to_module[name] = value
+
+
+_add_compat(globals())

+ 86 - 0
magic/__init__.pyi

@@ -0,0 +1,86 @@
+import ctypes.util
+import threading
+from typing import Any, Text, Optional, Union
+
+class MagicException(Exception):
+    message: Any = ...
+    def __init__(self, message: Any) -> None: ...
+
+class Magic:
+    flags: int = ...
+    cookie: Any = ...
+    lock: threading.Lock = ...
+    def __init__(self, mime: bool = ..., magic_file: Optional[Any] = ..., mime_encoding: bool = ..., keep_going: bool = ..., uncompress: bool = ..., raw: bool = ...) -> None: ...
+    def from_buffer(self, buf: Union[bytes, str]) -> Text: ...
+    def from_file(self, filename: Union[bytes, str]) -> Text: ...
+    def from_descriptor(self, fd: int, mime: bool = ...) -> Text: ...
+    def setparam(self, param: Any, val: Any): ...
+    def getparam(self, param: Any): ...
+    def __del__(self) -> None: ...
+
+def from_file(filename: Union[bytes, str], mime: bool = ...) -> Text: ...
+def from_buffer(buffer: Union[bytes, str], mime: bool = ...) -> Text: ...
+def from_descriptor(fd: int, mime: bool = ...) -> Text: ...
+
+libmagic: Any
+dll: Any
+windows_dlls: Any
+platform_to_lib: Any
+platform: Any
+magic_t = ctypes.c_void_p
+
+def errorcheck_null(result: Any, func: Any, args: Any): ...
+def errorcheck_negative_one(result: Any, func: Any, args: Any): ...
+def maybe_decode(s: Union[bytes, str]) -> str: ...
+def coerce_filename(filename: Any): ...
+
+magic_open: Any
+magic_close: Any
+magic_error: Any
+magic_errno: Any
+
+def magic_file(cookie: Any, filename: Any): ...
+def magic_buffer(cookie: Any, buf: Any): ...
+def magic_descriptor(cookie: Any, fd: int): ...
+def magic_load(cookie: Any, filename: Any): ...
+
+magic_setflags: Any
+magic_check: Any
+magic_compile: Any
+
+def magic_setparam(cookie: Any, param: Any, val: Any): ...
+def magic_getparam(cookie: Any, param: Any): ...
+
+magic_version: Any
+
+def version(): ...
+
+MAGIC_NONE: int
+MAGIC_DEBUG: int
+MAGIC_SYMLINK: int
+MAGIC_COMPRESS: int
+MAGIC_DEVICES: int
+MAGIC_MIME_TYPE: int
+MAGIC_MIME_ENCODING: int
+MAGIC_MIME: int
+MAGIC_CONTINUE: int
+MAGIC_CHECK: int
+MAGIC_PRESERVE_ATIME: int
+MAGIC_RAW: int
+MAGIC_ERROR: int
+MAGIC_NO_CHECK_COMPRESS: int
+MAGIC_NO_CHECK_TAR: int
+MAGIC_NO_CHECK_SOFT: int
+MAGIC_NO_CHECK_APPTYPE: int
+MAGIC_NO_CHECK_ELF: int
+MAGIC_NO_CHECK_ASCII: int
+MAGIC_NO_CHECK_TROFF: int
+MAGIC_NO_CHECK_FORTRAN: int
+MAGIC_NO_CHECK_TOKENS: int
+MAGIC_PARAM_INDIR_MAX: int
+MAGIC_PARAM_NAME_MAX: int
+MAGIC_PARAM_ELF_PHNUM_MAX: int
+MAGIC_PARAM_ELF_SHNUM_MAX: int
+MAGIC_PARAM_ELF_NOTES_MAX: int
+MAGIC_PARAM_REGEX_MAX: int
+MAGIC_PARAM_BYTES_MAX: int

+ 288 - 0
magic/compat.py

@@ -0,0 +1,288 @@
+# coding: utf-8
+
+'''
+Python bindings for libmagic
+'''
+
+import ctypes
+
+from collections import namedtuple
+
+from ctypes import *
+from ctypes.util import find_library
+
+
+def _init():
+    """
+    Loads the shared library through ctypes and returns a library
+    L{ctypes.CDLL} instance
+    """
+    return ctypes.cdll.LoadLibrary(find_library('magic'))
+
+
+_libraries = {}
+_libraries['magic'] = _init()
+
+# Flag constants for open and setflags
+MAGIC_NONE = NONE = 0
+MAGIC_DEBUG = DEBUG = 1
+MAGIC_SYMLINK = SYMLINK = 2
+MAGIC_COMPRESS = COMPRESS = 4
+MAGIC_DEVICES = DEVICES = 8
+MAGIC_MIME_TYPE = MIME_TYPE = 16
+MAGIC_CONTINUE = CONTINUE = 32
+MAGIC_CHECK = CHECK = 64
+MAGIC_PRESERVE_ATIME = PRESERVE_ATIME = 128
+MAGIC_RAW = RAW = 256
+MAGIC_ERROR = ERROR = 512
+MAGIC_MIME_ENCODING = MIME_ENCODING = 1024
+MAGIC_MIME = MIME = 1040  # MIME_TYPE + MIME_ENCODING
+MAGIC_APPLE = APPLE = 2048
+
+MAGIC_NO_CHECK_COMPRESS = NO_CHECK_COMPRESS = 4096
+MAGIC_NO_CHECK_TAR = NO_CHECK_TAR = 8192
+MAGIC_NO_CHECK_SOFT = NO_CHECK_SOFT = 16384
+MAGIC_NO_CHECK_APPTYPE = NO_CHECK_APPTYPE = 32768
+MAGIC_NO_CHECK_ELF = NO_CHECK_ELF = 65536
+MAGIC_NO_CHECK_TEXT = NO_CHECK_TEXT = 131072
+MAGIC_NO_CHECK_CDF = NO_CHECK_CDF = 262144
+MAGIC_NO_CHECK_TOKENS = NO_CHECK_TOKENS = 1048576
+MAGIC_NO_CHECK_ENCODING = NO_CHECK_ENCODING = 2097152
+
+MAGIC_NO_CHECK_BUILTIN = NO_CHECK_BUILTIN = 4173824
+
+FileMagic = namedtuple('FileMagic', ('mime_type', 'encoding', 'name'))
+
+
+class magic_set(Structure):
+    pass
+
+
+magic_set._fields_ = []
+magic_t = POINTER(magic_set)
+
+_open = _libraries['magic'].magic_open
+_open.restype = magic_t
+_open.argtypes = [c_int]
+
+_close = _libraries['magic'].magic_close
+_close.restype = None
+_close.argtypes = [magic_t]
+
+_file = _libraries['magic'].magic_file
+_file.restype = c_char_p
+_file.argtypes = [magic_t, c_char_p]
+
+_descriptor = _libraries['magic'].magic_descriptor
+_descriptor.restype = c_char_p
+_descriptor.argtypes = [magic_t, c_int]
+
+_buffer = _libraries['magic'].magic_buffer
+_buffer.restype = c_char_p
+_buffer.argtypes = [magic_t, c_void_p, c_size_t]
+
+_error = _libraries['magic'].magic_error
+_error.restype = c_char_p
+_error.argtypes = [magic_t]
+
+_setflags = _libraries['magic'].magic_setflags
+_setflags.restype = c_int
+_setflags.argtypes = [magic_t, c_int]
+
+_load = _libraries['magic'].magic_load
+_load.restype = c_int
+_load.argtypes = [magic_t, c_char_p]
+
+_compile = _libraries['magic'].magic_compile
+_compile.restype = c_int
+_compile.argtypes = [magic_t, c_char_p]
+
+_check = _libraries['magic'].magic_check
+_check.restype = c_int
+_check.argtypes = [magic_t, c_char_p]
+
+_list = _libraries['magic'].magic_list
+_list.restype = c_int
+_list.argtypes = [magic_t, c_char_p]
+
+_errno = _libraries['magic'].magic_errno
+_errno.restype = c_int
+_errno.argtypes = [magic_t]
+
+
+class Magic(object):
+    def __init__(self, ms):
+        self._magic_t = ms
+
+    def close(self):
+        """
+        Closes the magic database and deallocates any resources used.
+        """
+        _close(self._magic_t)
+
+    @staticmethod
+    def __tostr(s):
+        if s is None:
+            return None
+        if isinstance(s, str):
+            return s
+        try:  # keep Python 2 compatibility
+            return str(s, 'utf-8')
+        except TypeError:
+            return str(s)
+
+    @staticmethod
+    def __tobytes(b):
+        if b is None:
+            return None
+        if isinstance(b, bytes):
+            return b
+        try:  # keep Python 2 compatibility
+            return bytes(b, 'utf-8')
+        except TypeError:
+            return bytes(b)
+
+    def file(self, filename):
+        """
+        Returns a textual description of the contents of the argument passed
+        as a filename or None if an error occurred and the MAGIC_ERROR flag
+        is set. A call to errno() will return the numeric error code.
+        """
+        return Magic.__tostr(_file(self._magic_t, Magic.__tobytes(filename)))
+
+    def descriptor(self, fd):
+        """
+        Returns a textual description of the contents of the argument passed
+        as a file descriptor or None if an error occurred and the MAGIC_ERROR
+        flag is set. A call to errno() will return the numeric error code.
+        """
+        return Magic.__tostr(_descriptor(self._magic_t, fd))
+
+    def buffer(self, buf):
+        """
+        Returns a textual description of the contents of the argument passed
+        as a buffer or None if an error occurred and the MAGIC_ERROR flag
+        is set. A call to errno() will return the numeric error code.
+        """
+        return Magic.__tostr(_buffer(self._magic_t, buf, len(buf)))
+
+    def error(self):
+        """
+        Returns a textual explanation of the last error or None
+        if there was no error.
+        """
+        return Magic.__tostr(_error(self._magic_t))
+
+    def setflags(self, flags):
+        """
+        Set flags on the magic object which determine how magic checking
+        behaves; a bitwise OR of the flags described in libmagic(3), but
+        without the MAGIC_ prefix.
+
+        Returns -1 on systems that don't support utime(2) or utimes(2)
+        when PRESERVE_ATIME is set.
+        """
+        return _setflags(self._magic_t, flags)
+
+    def load(self, filename=None):
+        """
+        Must be called to load entries in the colon separated list of database
+        files passed as argument or the default database file if no argument
+        before any magic queries can be performed.
+
+        Returns 0 on success and -1 on failure.
+        """
+        return _load(self._magic_t, Magic.__tobytes(filename))
+
+    def compile(self, dbs):
+        """
+        Compile entries in the colon separated list of database files
+        passed as argument or the default database file if no argument.
+        The compiled files created are named from the basename(1) of each file
+        argument with ".mgc" appended to it.
+
+        Returns 0 on success and -1 on failure.
+        """
+        return _compile(self._magic_t, Magic.__tobytes(dbs))
+
+    def check(self, dbs):
+        """
+        Check the validity of entries in the colon separated list of
+        database files passed as argument or the default database file
+        if no argument.
+
+        Returns 0 on success and -1 on failure.
+        """
+        return _check(self._magic_t, Magic.__tobytes(dbs))
+
+    def list(self, dbs):
+        """
+        Check the validity of entries in the colon separated list of
+        database files passed as argument or the default database file
+        if no argument.
+
+        Returns 0 on success and -1 on failure.
+        """
+        return _list(self._magic_t, Magic.__tobytes(dbs))
+
+    def errno(self):
+        """
+        Returns a numeric error code. If return value is 0, an internal
+        magic error occurred. If return value is non-zero, the value is
+        an OS error code. Use the errno module or os.strerror() can be used
+        to provide detailed error information.
+        """
+        return _errno(self._magic_t)
+
+
+def open(flags):
+    """
+    Returns a magic object on success and None on failure.
+    Flags argument as for setflags.
+    """
+    return Magic(_open(flags))
+
+
+# Objects used by `detect_from_` functions
+mime_magic = Magic(_open(MAGIC_MIME))
+mime_magic.load()
+none_magic = Magic(_open(MAGIC_NONE))
+none_magic.load()
+
+
+def _create_filemagic(mime_detected, type_detected):
+    mime_type, mime_encoding = mime_detected.split('; ')
+
+    return FileMagic(name=type_detected, mime_type=mime_type,
+                     encoding=mime_encoding.replace('charset=', ''))
+
+
+def detect_from_filename(filename):
+    '''Detect mime type, encoding and file type from a filename
+
+    Returns a `FileMagic` namedtuple.
+    '''
+
+    return _create_filemagic(mime_magic.file(filename),
+                             none_magic.file(filename))
+
+
+def detect_from_fobj(fobj):
+    '''Detect mime type, encoding and file type from file-like object
+
+    Returns a `FileMagic` namedtuple.
+    '''
+
+    file_descriptor = fobj.fileno()
+    return _create_filemagic(mime_magic.descriptor(file_descriptor),
+                             none_magic.descriptor(file_descriptor))
+
+
+def detect_from_content(byte_content):
+    '''Detect mime type, encoding and file type from bytes
+
+    Returns a `FileMagic` namedtuple.
+    '''
+
+    return _create_filemagic(mime_magic.buffer(byte_content),
+                             none_magic.buffer(byte_content))

+ 38 - 30
setup.py

@@ -1,34 +1,42 @@
 #!/usr/bin/env python
 # -*- coding: utf-8 -*-
 
-from setuptools import setup
+import setuptools
+import io
+import os
+
+
+def read(file_name):
+    """Read a text file and return the content as a string."""
+    with io.open(os.path.join(os.path.dirname(__file__), file_name),
+                 encoding='utf-8') as f:
+        return f.read()
+
+setuptools.setup(
+    name='python-magic',
+    description='File type identification using libmagic',
+    author='Adam Hupp',
+    author_email='adam@hupp.org',
+    url="http://github.com/ahupp/python-magic",
+    version='0.4.20',
+    long_description=read('README.md'),
+    long_description_content_type='text/markdown',
+    packages=['magic'],
+    keywords="mime magic file",
+    license="MIT",
+    python_requires='>=2.7, !=3.0.*, !=3.1.*, !=3.2.*, !=3.3.*, !=3.4.*',
+    classifiers=[
+        'Intended Audience :: Developers',
+        'License :: OSI Approved :: MIT License',
+        'Programming Language :: Python',
+        'Programming Language :: Python :: 2.7',
+        'Programming Language :: Python :: 3',
+        'Programming Language :: Python :: 3.5',
+        'Programming Language :: Python :: 3.6',
+        'Programming Language :: Python :: 3.7',
+        'Programming Language :: Python :: 3.8',
+        'Programming Language :: Python :: 3.9',
+        'Programming Language :: Python :: Implementation :: CPython',
+    ],
+)
 
-setup(name='python-magic',
-      description='File type identification using libmagic',
-      author='Adam Hupp',
-      author_email='adam@hupp.org',
-      url="http://github.com/ahupp/python-magic",
-      version='0.4.15',
-      py_modules=['magic'],
-      long_description="""This module uses ctypes to access the libmagic file type
-identification library.  It makes use of the local magic database and
-supports both textual and MIME-type output.
-""",
-      keywords="mime magic file",
-      license="MIT",
-      test_suite='test',
-      classifiers=[
-          'Intended Audience :: Developers',
-          'License :: OSI Approved :: MIT License',
-          'Programming Language :: Python',
-          'Programming Language :: Python :: 2',
-          'Programming Language :: Python :: 2.6',
-          'Programming Language :: Python :: 2.7',
-          'Programming Language :: Python :: 3',
-          'Programming Language :: Python :: 3.3',
-          'Programming Language :: Python :: 3.4',
-          'Programming Language :: Python :: 3.5',
-          'Programming Language :: Python :: 3.6',
-          'Programming Language :: Python :: Implementation :: CPython',
-      ],
-      )

+ 11 - 0
test.ps1

@@ -0,0 +1,11 @@
+
+
+function TestInContainer($name) {
+    $TAG="python_magic/${name}:latest"
+    docker build -t $TAG -f "test/Dockerfile_${name}" .
+    docker run "python_magic/${name}:latest"
+}
+
+TestInContainer "xenial"
+TestInContainer "bionic"
+TestInContainer "focal"

+ 5 - 0
test/Dockerfile_archlinux

@@ -0,0 +1,5 @@
+FROM archlinux:20200505
+RUN yes | pacman -Syyu --overwrite '*'
+RUN yes | pacman -S python python2 file which
+COPY . /python-magic
+CMD cd /python-magic/test && python3 ./run.py

+ 8 - 0
test/Dockerfile_bionic

@@ -0,0 +1,8 @@
+FROM ubuntu:bionic
+RUN apt-get update
+RUN apt-get -y install python
+RUN apt-get -y install python3
+RUN apt-get -y install locales
+RUN locale-gen en_US.UTF-8
+COPY . /python-magic
+CMD cd /python-magic/test && python3 ./run.py

+ 5 - 0
test/Dockerfile_centos7

@@ -0,0 +1,5 @@
+FROM centos:7
+RUN yum -y update
+RUN yum -y install file-devel python3 python2 which
+COPY . /python-magic
+CMD cd /python-magic/test && SKIP_FROM_DESCRIPTOR=1 python3 ./run.py

+ 5 - 0
test/Dockerfile_centos8

@@ -0,0 +1,5 @@
+FROM centos:8
+RUN yum -y update
+RUN yum -y install file-libs python3 python2 which
+COPY . /python-magic
+CMD cd /python-magic/test && python3 ./run.py

+ 8 - 0
test/Dockerfile_focal

@@ -0,0 +1,8 @@
+FROM ubuntu:focal
+RUN apt-get update
+RUN apt-get -y install python2
+RUN apt-get -y install python3
+RUN apt-get -y install locales
+RUN locale-gen en_US.UTF-8
+COPY . /python-magic
+CMD cd /python-magic/test && python3 ./run.py

+ 8 - 0
test/Dockerfile_xenial

@@ -0,0 +1,8 @@
+FROM ubuntu:xenial
+RUN apt-get update
+RUN apt-get -y install python
+RUN apt-get -y install python3
+RUN apt-get -y install locales
+RUN locale-gen en_US.UTF-8
+COPY . /python-magic
+CMD cd /python-magic/test && python3 ./run.py

+ 10 - 0
test/README

@@ -0,0 +1,10 @@
+To run the tests across a selection of Ubuntu LTS versions:
+
+docker build -t "python_magic/xenial:latest" -f test/Dockerfile_xenial .
+docker build -t "python_magic/bionic:latest" -f test/Dockerfile_bionic .
+docker build -t "python_magic/focal:latest" -f test/Dockerfile_focal .
+
+docker run python_magic/xenial:latest
+docker run python_magic/bionic:latest
+docker run python_magic/focal:latest
+

+ 46 - 0
test/libmagic_test.py

@@ -0,0 +1,46 @@
+# coding: utf-8
+
+import unittest
+import os
+import magic
+
+# magic_descriptor is broken (?) in centos 7, so don't run those tests
+SKIP_FROM_DESCRIPTOR = bool(os.environ.get('SKIP_FROM_DESCRIPTOR'))
+
+class MagicTestCase(unittest.TestCase):
+    filename = 'testdata/test.pdf'
+    expected_mime_type = 'application/pdf'
+    expected_encoding = 'us-ascii'
+    expected_name = 'PDF document, version 1.2'
+
+    def assert_result(self, result):
+        self.assertEqual(result.mime_type, self.expected_mime_type)
+        self.assertEqual(result.encoding, self.expected_encoding)
+        self.assertEqual(result.name, self.expected_name)
+
+    def test_detect_from_filename(self):
+        result = magic.detect_from_filename(self.filename)
+        self.assert_result(result)
+
+    def test_detect_from_fobj(self):
+
+        if SKIP_FROM_DESCRIPTOR:
+            self.skipTest("magic_descriptor is broken in this version of libmagic")
+
+
+        with open(self.filename) as fobj:
+            result = magic.detect_from_fobj(fobj)
+        self.assert_result(result)
+
+    def test_detect_from_content(self):
+        # differ from upstream by opening file in binary mode,
+        # this avoids hitting a bug in python3+libfile bindings
+        # see https://github.com/ahupp/python-magic/issues/152
+        # for a similar issue
+        with open(self.filename, 'rb') as fobj:
+            result = magic.detect_from_content(fobj.read(4096))
+        self.assert_result(result)
+
+
+if __name__ == '__main__':
+    unittest.main()

+ 35 - 0
test/run.py

@@ -0,0 +1,35 @@
+import subprocess
+import os.path
+import sys
+
+this_dir = os.path.dirname(sys.argv[0])
+
+new_env = dict(os.environ)
+new_env.update({
+    'LC_ALL': 'en_US.UTF-8',
+    'PYTHONPATH': os.path.join(this_dir, ".."),
+})
+
+
+def has_py(version):
+    ret = subprocess.run("which %s" % version, shell=True, stdout=subprocess.DEVNULL)
+    return ret.returncode == 0
+
+
+def run_test(versions):
+    found = False
+    for i in versions:
+        if not has_py(i):
+            # if this version doesn't exist in path, skip
+            continue
+        found = True
+        print("Testing %s" % i)
+        subprocess.run([i, os.path.join(this_dir, "test.py")], env=new_env, check=True)
+        subprocess.run([i, os.path.join(this_dir, "libmagic_test.py")], env=new_env, check=True)
+
+    if not found:
+        sys.exit("No versions found: " + str(versions))
+
+run_test(["python2", "python2.7"])
+run_test(["python3.5", "python3.6", "python3.7", "python3.8", "python3.9"])
+

+ 0 - 14
test/run.sh

@@ -1,14 +0,0 @@
-#!/bin/sh
-
-
-# ensure we can use unicode filenames in the test
-export LC_ALL=en_US.UTF-8
-THISDIR=`dirname $0`
-export PYTHONPATH=${THISDIR}/..
-
-echo "python2.6"
-python2.6 ${THISDIR}/test.py
-echo "python2.7"
-python2.7 ${THISDIR}/test.py
-echo "python3.0"
-python3 ${THISDIR}/test.py

+ 143 - 31
test/test.py

@@ -1,52 +1,99 @@
-import os, sys
+import os
+
 # for output which reports a local time
 os.environ['TZ'] = 'GMT'
+
+if os.environ.get('LC_ALL', '') != 'en_US.UTF-8':
+    # this ensure we're in a utf-8 default filesystem encoding which is
+    # necessary for some tests
+    raise Exception("must run `export LC_ALL=en_US.UTF-8` before running test suite")
+
 import shutil
 import os.path
 import unittest
 
 import magic
+import sys
+
+# magic_descriptor is broken (?) in centos 7, so don't run those tests
+SKIP_FROM_DESCRIPTOR = bool(os.environ.get('SKIP_FROM_DESCRIPTOR'))
 
 class MagicTest(unittest.TestCase):
-    TESTDATA_DIR = os.path.join(os.path.dirname(__file__), 'testdata')
+    TESTDATA_DIR = os.path.join(os.path.dirname(os.path.abspath(__file__)), 'testdata')
 
-    def assert_values(self, m, expected_values):
+    def test_version(self):
+        try:
+            self.assertTrue(magic.version() > 0)
+        except NotImplementedError:
+            pass
+
+    def test_fs_encoding(self):
+        self.assertEqual('utf-8', sys.getfilesystemencoding().lower())
+
+    def assert_values(self, m, expected_values, buf_equals_file=True):
         for filename, expected_value in expected_values.items():
             try:
                 filename = os.path.join(self.TESTDATA_DIR, filename)
             except TypeError:
-                filename = os.path.join(self.TESTDATA_DIR.encode('utf-8'), filename)
+                filename = os.path.join(
+                    self.TESTDATA_DIR.encode('utf-8'), filename)
 
-            
             if type(expected_value) is not tuple:
                 expected_value = (expected_value,)
 
-            for i in expected_value:
-                with open(filename, 'rb') as f:
-                    buf_value = m.from_buffer(f.read())
+            with open(filename, 'rb') as f:
+                buf_value = m.from_buffer(f.read())
+
+            file_value = m.from_file(filename)
+
+            if buf_equals_file:
+                self.assertEqual(buf_value, file_value)
 
-                file_value = m.from_file(filename)
-                if buf_value == i and file_value == i:
-                    break
-            else:
-                self.assertTrue(False, "no match for " + repr(expected_value))
+            for value in (buf_value, file_value):
+                self.assertIn(value, expected_value)
+
+    def test_from_file_str_and_bytes(self):
+        filename = os.path.join(self.TESTDATA_DIR, "test.pdf")
+
+        self.assertEqual('application/pdf',
+                         magic.from_file(filename, mime=True))
+        self.assertEqual('application/pdf',
+                         magic.from_file(filename.encode('utf-8'), mime=True))
+
+    def test_from_descriptor_str_and_bytes(self):
+        if SKIP_FROM_DESCRIPTOR:
+            self.skipTest("magic_descriptor is broken in this version of libmagic")
+
+        filename = os.path.join(self.TESTDATA_DIR, "test.pdf")
+        with open(filename) as f:
+            self.assertEqual('application/pdf',
+                             magic.from_descriptor(f.fileno(), mime=True))
+            self.assertEqual('application/pdf',
+                             magic.from_descriptor(f.fileno(), mime=True))
 
     def test_from_buffer_str_and_bytes(self):
+        if SKIP_FROM_DESCRIPTOR:
+            self.skipTest("magic_descriptor is broken in this version of libmagic")
         m = magic.Magic(mime=True)
-        s = '#!/usr/bin/env python\nprint("foo")'
-        self.assertEqual("text/x-python", m.from_buffer(s))
-        b = b'#!/usr/bin/env python\nprint("foo")'
-        self.assertEqual("text/x-python", m.from_buffer(b))
-                
+
+        self.assertTrue(
+            m.from_buffer('#!/usr/bin/env python\nprint("foo")')
+            in ("text/x-python", "text/x-script.python"))
+        self.assertTrue(
+            m.from_buffer(b'#!/usr/bin/env python\nprint("foo")')
+            in ("text/x-python", "text/x-script.python"))
+
     def test_mime_types(self):
-        dest = os.path.join(MagicTest.TESTDATA_DIR, b'\xce\xbb'.decode('utf-8'))
+        dest = os.path.join(MagicTest.TESTDATA_DIR,
+                            b'\xce\xbb'.decode('utf-8'))
         shutil.copyfile(os.path.join(MagicTest.TESTDATA_DIR, 'lambda'), dest)
         try:
             m = magic.Magic(mime=True)
             self.assert_values(m, {
-                'magic._pyc_': 'application/octet-stream',
+                'magic._pyc_': ('application/octet-stream', 'text/x-bytecode.python'),
                 'test.pdf': 'application/pdf',
-                'test.gz': 'application/gzip',
+                'test.gz': ('application/gzip', 'application/x-gzip'),
+                'test.snappy.parquet': 'application/octet-stream',
                 'text.txt': 'text/plain',
                 b'\xce\xbb'.decode('utf-8'): 'text/plain',
                 b'\xce\xbb': 'text/plain',
@@ -56,19 +103,61 @@ class MagicTest(unittest.TestCase):
 
     def test_descriptions(self):
         m = magic.Magic()
-        os.environ['TZ'] = 'UTC'  # To get the last modified date of test.gz in UTC
+        os.environ['TZ'] = 'UTC'  # To get last modified date of test.gz in UTC
         try:
             self.assert_values(m, {
                 'magic._pyc_': 'python 2.4 byte-compiled',
                 'test.pdf': 'PDF document, version 1.2',
                 'test.gz':
-                ('gzip compressed data, was "test", from Unix, last modified: Sun Jun 29 01:32:52 2008',
-                 'gzip compressed data, was "test", last modified: Sun Jun 29 01:32:52 2008, from Unix'),
+                    ('gzip compressed data, was "test", from Unix, last '
+                     'modified: Sun Jun 29 01:32:52 2008',
+                     'gzip compressed data, was "test", last modified'
+                     ': Sun Jun 29 01:32:52 2008, from Unix',
+                     'gzip compressed data, was "test", last modified'
+                     ': Sun Jun 29 01:32:52 2008, from Unix, original size 15',
+                     'gzip compressed data, was "test", '
+                     'last modified: Sun Jun 29 01:32:52 2008, '
+                     'from Unix, original size modulo 2^32 15',
+                     'gzip compressed data, was "test", last modified'
+                     ': Sun Jun 29 01:32:52 2008, from Unix, truncated'
+                     ),
                 'text.txt': 'ASCII text',
-            })
+                'test.snappy.parquet': ('Apache Parquet', 'Par archive data'),
+            }, buf_equals_file=False)
         finally:
             del os.environ['TZ']
 
+    def test_extension(self):
+        try:
+            m = magic.Magic(extension=True)
+            self.assert_values(m, {
+                # some versions return '' for the extensions of a gz file,
+                # including w/ the command line.  Who knows...
+                'test.gz': ('gz/tgz/tpz/zabw/svgz', '', '???'),
+                'name_use.jpg': 'jpeg/jpg/jpe/jfif',
+            })
+        except NotImplementedError:
+            self.skipTest('MAGIC_EXTENSION not supported in this version')
+
+    def test_unicode_result_nonraw(self):
+        m = magic.Magic(raw=False)
+        src = os.path.join(MagicTest.TESTDATA_DIR, 'pgpunicode')
+        result = m.from_file(src)
+        # NOTE: This check is added as otherwise some magic files don't identify the test case as a PGP key.
+        if 'PGP' in result:
+            assert r"PGP\011Secret Sub-key -" == result
+        else:
+            raise unittest.SkipTest("Magic file doesn't return expected type.")
+
+    def test_unicode_result_raw(self):
+        m = magic.Magic(raw=True)
+        src = os.path.join(MagicTest.TESTDATA_DIR, 'pgpunicode')
+        result = m.from_file(src)
+        if 'PGP' in result:
+            assert b'PGP\tSecret Sub-key -' == result.encode('utf-8')
+        else:
+            raise unittest.SkipTest("Magic file doesn't return expected type.")
+
     def test_mime_encodings(self):
         m = magic.Magic(mime_encoding=True)
         self.assert_values(m, {
@@ -92,20 +181,43 @@ class MagicTest(unittest.TestCase):
 
         m = magic.Magic(mime=True)
         self.assertEqual(m.from_file(filename), 'image/jpeg')
-        
-        m = magic.Magic(mime=True, keep_going=True)
-        self.assertEqual(m.from_file(filename), 'image/jpeg')
 
+        try:
+            # this will throw if you have an "old" version of the library
+            # I'm otherwise not sure how to query if keep_going is supported
+            magic.version()
+            m = magic.Magic(mime=True, keep_going=True)
+            self.assertEqual(m.from_file(filename),
+                             'image/jpeg\\012- application/octet-stream')
+        except NotImplementedError:
+            pass
 
     def test_rethrow(self):
         old = magic.magic_buffer
         try:
-            def t(x,y):
+            def t(x, y):
                 raise magic.MagicException("passthrough")
+
             magic.magic_buffer = t
-            
-            self.assertRaises(magic.MagicException, magic.from_buffer, "hello", True)
+
+            with self.assertRaises(magic.MagicException):
+                magic.from_buffer("hello", True)
         finally:
             magic.magic_buffer = old
+
+    def test_getparam(self):
+        m = magic.Magic(mime=True)
+        try:
+            m.setparam(magic.MAGIC_PARAM_INDIR_MAX, 1)
+            self.assertEqual(m.getparam(magic.MAGIC_PARAM_INDIR_MAX), 1)
+        except NotImplementedError:
+            pass
+
+    def test_name_count(self):
+        m = magic.Magic()
+        with open(os.path.join(self.TESTDATA_DIR, 'name_use.jpg'), 'rb') as f:
+            m.from_buffer(f.read())
+
+
 if __name__ == '__main__':
     unittest.main()

BIN
test/testdata/name_use.jpg


+ 1 - 0
test/testdata/pgpunicode

@@ -0,0 +1 @@
+qʐ

BIN
test/testdata/test.snappy.parquet


+ 21 - 0
test_docker.sh

@@ -0,0 +1,21 @@
+#!/bin/bash
+
+# Test with various versions of ubuntu.  This more or less re-creates the
+# Travis CI test environment
+
+set -e
+
+function TestInContainer {
+    local name="$1"
+    local TAG="python_magic/${name}:latest"
+    docker build -t $TAG -f "test/Dockerfile_${name}" .
+    docker run "python_magic/${name}:latest"
+}
+
+TestInContainer "xenial"
+TestInContainer "bionic"
+TestInContainer "focal"
+TestInContainer "centos7"
+TestInContainer "centos8"
+TestInContainer "archlinux"
+

+ 47 - 0
tox.ini

@@ -0,0 +1,47 @@
+[tox]
+envlist =
+    coverage-clean,
+    py27,
+    py35,
+    py36,
+    py37,
+    py38,
+    py39,
+    coverage-report,
+    mypy
+
+[testenv]
+commands =
+    coverage run --source=magic ./test/test.py
+
+setenv =
+  COVERAGE_FILE=.coverage.{envname}
+  LC_ALL=en_US.UTF-8   
+deps =
+    .[test]
+    zope.testrunner    
+    coverage
+
+[testenv:coverage-clean]
+deps = coverage
+setenv =
+  COVERAGE_FILE=.coverage
+skip_install = true
+commands = coverage erase
+
+[testenv:coverage-report]
+deps = coverage
+setenv =
+  COVERAGE_FILE=.coverage
+skip_install = true
+commands =
+    coverage combine
+    coverage report
+    coverage html
+    coverage
+
+[testenv:mypy]
+deps = mypy
+skip_install = true
+commands =
+    mypy magic.pyi

+ 6 - 0
upload.sh

@@ -0,0 +1,6 @@
+#!/bin/sh
+
+python3 setup.py clean --all
+python3 setup.py sdist bdist_wheel
+#python3 -m twine upload dist/*
+